<?php
/**
* Plugin Name: Deklaracja dostepnosci WCAG 2.1
* Plugin URI: http://deklaracjadostepnosci.eu/
* Description: Wtyczka umożliwiająca automatyczne wygenerowanie spełnienia deklaracji dostępności WCAG 2.1 wymaganej na podstawie art. 12 pkt 7 ustawy z dnia 4 kwietnia 2019 r. o dostępności cyfrowej stron internetowych i aplikacji mobilnych podmiotów publicznych (Dz. U. poz. 848), dalej zwanej „ustawą o dostępności cyfrowej”.
* Version: 1.1
* Author: deklaracjadostepnosci.eu
* Author URI: http://deklaracjadostepnosci.eu/
* Text Domain: deklaracjadostepnosci
**/






function deklaracjadostepnosci_register_options_page() {
  add_options_page('Deklaracja dostępności', 'Deklaracja dostępności', 'manage_options', 'deklaracjadostepnosci', 'deklaracjadostepnosci_options_page');
}
add_action('admin_menu', 'deklaracjadostepnosci_register_options_page');






function deklaracjadostepnosci_action_links( $links ) {

	$links = array_merge( array(
		'<a href="' . esc_url( admin_url( '/options-general.php?page=deklaracjadostepnosci' ) ) . '">' . __( 'Settings', 'textdomain' ) . '</a>'
	), $links );

	return $links;

}
add_action( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'deklaracjadostepnosci_action_links' );



function hook_deklaracjameta() {
    ?>
<meta name="deklaracja-dostępności" content="<?php echo site_url('deklaracjadostepnosci'); ?>"> 
    <?php
    
    // 
    if(get_option('deklaracjadostepnosci_on', '0') && get_option('deklaracjadostepnosci_optimize', '0') && in_array($_SERVER['REMOTE_ADDR'], array('3.20.59.76','3.20.59.75','3.20.59.74','3.20.59.77','3.20.59.78'))){
	
	if($css= get_option('deklaracjadostepnosci_webaimcss', '')){
		echo '<style>'.$css.'</style>';
	}
}
}
add_action('wp_head', 'hook_deklaracjameta');


function hook_deklaracjacontent($content) {
	
	 if(get_option('deklaracjadostepnosci_on', '0') && get_option('deklaracjadostepnosci_optimize', '0') ){
	
	$content = str_replace(
array('alt=""','src=""')

,
array('alt="obrazek"','src="/1x1.gif"')


,$content);

	 }


	return $content;
}

add_filter( 'the_content', 'hook_deklaracjacontent' );





function deklaracjadostepnosci_register_settings() {
  // add_option( 'deklaracjadostepnosci_option_name', 'This is my option value.');
   register_setting( 'deklaracjadostepnosci_options_group', 'deklaracjadostepnosci_option_name', 'deklaracjadostepnosci_callback' );
   
   add_settings_section(
        'my-settings-section', // id of the section
        'Ustawienia', // title to be displayed
        '', // callback function to be called when opening section, currently empty
        'my-settings-page' // page on which to display the section
    );
   

	$set=array(
	'deklaracjadostepnosci_on'=>'Deklaracja włączona',
	'deklaracjadostepnosci_nazwa_podmiotu'=>'Nazwa podmiotu',
	'deklaracjadostepnosci_status'=>'Status dostępności',
	'deklaracjadostepnosci_status_text_add'=>'Dodatkowy tekst wyjaśniający co nie zostało spełnione - o ile nie zostało',
	'deklaracjadostepnosci_status_data'=>'Data ustawienia statusu',
	'deklaracjadostepnosci_kontakt_nazwa'=>'Kontakt - imię i nazwisko',
	'deklaracjadostepnosci_kontakt_email'=>'Kontakt - e-mail',
	'deklaracjadostepnosci_kontakt_telefon'=>'Kontakt - telefon',
	'deklaracjadostepnosci_architektura_0_0'=>'Architektura dostępności poz. 1 - nagłówek',
	'deklaracjadostepnosci_architektura_0_1'=>'Architektura dostępności poz. 1 - opis',

	
	'deklaracjadostepnosci_architektura_1_0'=>'Architektura dostępności poz. 2 - nagłówek',
	'deklaracjadostepnosci_architektura_1_1'=>'Architektura dostępności poz. 2 - opis',

	
	'deklaracjadostepnosci_architektura_2_0'=>'Architektura dostępności poz. 3 - nagłówek',
	'deklaracjadostepnosci_architektura_2_1'=>'Architektura dostępności poz. 3 - opis',

	
	'deklaracjadostepnosci_architektura_3_0'=>'Architektura dostępności poz. 4 - nagłówek',
	'deklaracjadostepnosci_architektura_3_1'=>'Architektura dostępności poz. 4 - opis',

	
	'deklaracjadostepnosci_architektura_4_0'=>'Architektura dostępności poz. 5 - nagłówek',
	'deklaracjadostepnosci_architektura_4_1'=>'Architektura dostępności poz. 5 - opis',

	'deklaracjadostepnosci_optimize'=>'Napraw błędy WCAG 2.1',
	'deklaracjadostepnosci_webaimcss'=>'CSS dla walidatora wave.webaim.org',
	
	
	);
	
	foreach($set as $k=>$v){
		
		if(!$v){
			continue;
		}
		
		register_setting(
		    'my-settings-page', // option group
		    $k
		);
		
		add_settings_field(
		    'id-'.$k, // id of the settings field
		    $v, // title
		    'input_'.$k, // callback function
		    'my-settings-page', // page on which settings display
		    'my-settings-section' // section on which to show settings
		);
	}
	
	
  
	    
		
		
}



add_action( 'admin_init', 'deklaracjadostepnosci_register_settings' );




/*
		$architektura_arr=array(
		array(get_option('deklaracjadostepnosci_architektura_0_0', ''),get_option('deklaracjadostepnosci_architektura_0_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_1_0', ''),get_option('deklaracjadostepnosci_architektura_1_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_2_0', ''),get_option('deklaracjadostepnosci_architektura_2_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_3_0', ''),get_option('deklaracjadostepnosci_architektura_3_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_4_0', ''),get_option('deklaracjadostepnosci_architektura_4_1', '')),
 * 
 *  */

 
 
 
 


// 
 
  function input_deklaracjadostepnosci_webaimcss() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
	echo '<p>Naprawiaj błędy kontrastu testując je bezpośrednio na walidatorze <a href="https://wave.webaim.org/">https://wave.webaim.org/</a>.<br> CSS tu umieszczony pokaże się tylko dla walidatora dzięki czemu możesz bezpieczenie naprawiać swoją stronę.</p>';
}
 
 
 function input_deklaracjadostepnosci_optimize() {
  	
	$k=str_replace('input_','',__FUNCTION__);
	$val = esc_attr(get_option($k, ''));
	

 
	echo '<label><input id="idk-'.$k.'" type="checkbox"';
	
	if($val){
		echo ' checked ';
	}
	
	echo '  name="'.$k.'" value="1"> tak</label>
	<p>Zaznaczenie tej opcji usprawnia pracę nad przejściem walidacji WCAG</p>';
	
	

} 
 
  function input_deklaracjadostepnosci_on() {
  	
	$k=str_replace('input_','',__FUNCTION__);
	$val = esc_attr(get_option($k, ''));
	
	$hecant=true;
	
	$content=@file_get_contents('http://deklaracjadostepnosci.eu/check.php?url='.site_url());
	if(trim($content)==='on'){
		$hecant=false;
	}

	
	echo '<label><input id="idk-'.$k.'" type="checkbox"';
	
	if($val){
		echo ' checked ';
	}elseif($hecant){
		echo ' disabled ';
	}
	
	echo '  name="'.$k.'" value="1"> tak</label>';
	
	
	if(!$val && $hecant){
		echo '<p style="color:red;font-weight:bold">Aby włączyć skontaktuj się z nami pod adresem <a href="http://deklaracjadostepnosci.eu/" target="_blank">http://deklaracjadostepnosci.eu/</a></p>';
	}
	

} 
 
 function input_deklaracjadostepnosci_architektura_0_0() {
    deklaracjadostepnosci_input(__FUNCTION__);
} 
 
 function input_deklaracjadostepnosci_architektura_0_1() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
 
 
 
 function input_deklaracjadostepnosci_architektura_1_0() {
    deklaracjadostepnosci_input(__FUNCTION__);
} 
 
 function input_deklaracjadostepnosci_architektura_1_1() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
 
 
 
 
 function input_deklaracjadostepnosci_architektura_2_0() {
    deklaracjadostepnosci_input(__FUNCTION__);
} 
 
 function input_deklaracjadostepnosci_architektura_2_1() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
 

 
 
 function input_deklaracjadostepnosci_architektura_3_0() {
    deklaracjadostepnosci_input(__FUNCTION__);
} 
 
 function input_deklaracjadostepnosci_architektura_3_1() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
 
 
 
 
 function input_deklaracjadostepnosci_architektura_4_0() {
    deklaracjadostepnosci_input(__FUNCTION__);
} 
 
 function input_deklaracjadostepnosci_architektura_4_1() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
 
 
 function input_deklaracjadostepnosci_kontakt_nazwa() {
    deklaracjadostepnosci_input(__FUNCTION__);
}
 
 
 function input_deklaracjadostepnosci_kontakt_email() {
    deklaracjadostepnosci_input(__FUNCTION__);
}
 
 
 function input_deklaracjadostepnosci_kontakt_telefon() {
    deklaracjadostepnosci_input(__FUNCTION__);
}
 
 
 
 
function input_deklaracjadostepnosci_nazwa_podmiotu() {
    deklaracjadostepnosci_input(__FUNCTION__);
}

function input_deklaracjadostepnosci_status() {
    deklaracjadostepnosci_input(__FUNCTION__,'','selectbox',array(
	'Strona internetowa jest zgodna z ustawą',
	'Strona internetowa jest częściowo zgodna z ustawą',
	'Strona internetowa jest niezgodna z ustawą',
	
	
	));
}


function input_deklaracjadostepnosci_status_text_add() {
    deklaracjadostepnosci_input(__FUNCTION__,'','textarea');
}
function input_deklaracjadostepnosci_status_data() {
    deklaracjadostepnosci_input(__FUNCTION__,date('Y-m-d'));
}





 function deklaracjadostepnosci_input($k,$def='',$type='',$options=array()) {
	$k=str_replace('input_','',$k);
	$val = esc_attr(get_option($k, ''));
	if(empty($val) && $def){
		$val=$def;
	}
	echo '<div>';
	
	switch($type){
		
		
		
		case 'selectbox':
			echo '<select style="min-width:500px;" id="idk-'.$k.'" name="'.$k.'">';
			if(!empty($options)){
				foreach($options as $k=>$v){
					echo '<option value="'.$k.'" ';
					
					if($val == $k){
						echo ' selected ';
					}
					
					echo '>'.esc_attr($v).'</option>';
				}
			}
			echo '</select>';
		break;
		
		case 'textarea':
			echo '<textarea style="min-width:500px;min-height:100px;" id="idk-'.$k.'" name="'.$k.'">'.$val.'</textarea>';
		break;
		
		default:
			echo '<input style="min-width:500px;" id="idk-'.$k.'" type="text" name="'.$k.'" value="'.$val.'">';
	}
	
	echo '</div>';
 
 }
 



function deklaracjadostepnosci_options_page()
{
	
	if (!current_user_can('manage_options')) {
        return;
    }
	
  echo '<div id="deklaracjadostepnosci_admin">
  <h3>Adres do deklaracji:</h3>
  <p><a href="'.site_url('deklaracjadostepnosci').'" target="_blank">'.site_url('deklaracjadostepnosci').'</a></p>
  </div>

  
  
  ';
  
  ?>
  
  

    <form method="POST" action="options.php">
        <?php settings_fields('my-settings-page');?>
        <?php do_settings_sections('my-settings-page')?>
        <?php submit_button();?>
    </form>
    
    
  <?php
}






class deklaracjaPages {

    public function __construct() {
        add_filter( 'the_posts', array( $this, 'deklaracja_pages' ) );
    }

    /**
     * Internally registers pages we want to deklaracja. Array key is the slug under which it is being available from the frontend
     * @return mixed
     */
    private static function get_deklaracja_pages() {
    	
		
		
		
        //http://example.com/deklaracjapage1
        
        $nazwa_podmiotu=get_option('deklaracjadostepnosci_nazwa_podmiotu', '');
		$status=get_option('deklaracjadostepnosci_status', '');
   		$status_text_add=get_option('deklaracjadostepnosci_status_text_add', '');
		$status_data=get_option('deklaracjadostepnosci_status_data', '');
   		$kontakt_nazwa=get_option('deklaracjadostepnosci_kontakt_nazwa', '');
		$kontakt_email=get_option('deklaracjadostepnosci_kontakt_email', '');
		$kontakt_telefon=get_option('deklaracjadostepnosci_kontakt_telefon', '');
		
		$architektura_arr=array(
		array(get_option('deklaracjadostepnosci_architektura_0_0', ''),get_option('deklaracjadostepnosci_architektura_0_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_1_0', ''),get_option('deklaracjadostepnosci_architektura_1_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_2_0', ''),get_option('deklaracjadostepnosci_architektura_2_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_3_0', ''),get_option('deklaracjadostepnosci_architektura_3_1', '')),
		array(get_option('deklaracjadostepnosci_architektura_4_0', ''),get_option('deklaracjadostepnosci_architektura_4_1', '')),
		); // array(array('title','desc'))
		
		$aplikacje='';
		
		
		if(!empty($status_text_add)){
			$status_text_add='<br>'.$status_text_add;
		}
		
		
		
		
		
		
		
		/* które wymagania nie zostały spełnione, na przykład ”filmy nie posiadają napisów dla osób głuchych”, „formularz kontaktowy nie posiada dowiązanych etykiet tekstowych”, „mapa placówek medycznych nie jest dostępna” itp. */
		
		
		
        // <p id="a11y-ocena">link do dokumentu z analizą o nadmiernym obciążeniu. Identyfikator jest opcjonalny;</p>
        // <p id="a11y-audytor">nazwa podmiotu zewnętrznego, który przeprowadził badanie dostępności. Identyfikator jest opcjonalny;</p>
   
   
   
   if($aplikacje){
   	$aplikacje='<p id="a11y-aplikacje">'.$aplikacje.'</p>';
   }
   
   
   $architektura='';
		if(!empty($architektura_arr)){
			foreach($architektura_arr as $k=>$v){
				if(!$v[0] && !$v[1]){
					continue;
				}
				$architektura.='<h7 id="a11y-architektura">'.$v[0].'</h7><p>'.$v[1].'</p>';
				
			}
		}


	   	$status_text_arr=array(
		'Strona internetowa jest zgodna z ustawą z dnia 4 kwietnia 2019 r. o dostępności cyfrowej stron internetowych i aplikacji mobilnych podmiotów publicznych.',
		'Strona internetowa jest częściowo zgodna z ustawą z dnia 4 kwietnia 2019 r. o dostępności cyfrowej stron internetowych i aplikacji mobilnych podmiotów publicznych z powodu niezgodności lub wyłączeń wymienionych poniżej. '.$status_text_add,
		'Strona internetowa jest niezgodna z ustawą z dnia 4 kwietnia 2019 r. o dostępności cyfrowej stron internetowych i aplikacji mobilnych podmiotów publicznych. Niezgodność (niezgodności) lub wyłączenia wymieniono poniżej. '.$status_text_add
		);
        $status_text=$status_text_arr[0];
		
		if(!empty($status_text_arr[$status])){
			$status_text=$status_text_arr[$status];
		}
		
		if(empty($status_data)){
			$status_data=date('Y-m-d');
		}
		
		
        $deklaracja_pages['deklaracjadostepnosci'] = array(
            'title'   => 'Deklaracja dostępności',
            'content' => '
        
			<div id="deklaracjadostepnosci">
			<p id="a11y-wstep"><span id="a11y-podmiot">'.$nazwa_podmiotu.'</span> zobowiązuje się zapewnić dostępność swojej strony internetowej zgodnie z przepisami ustawy z dnia 4 kwietnia 2019 r. o dostępności cyfrowej stron internetowych i aplikacji mobilnych podmiotów publicznych. Oświadczenie w sprawie dostępności ma zastosowanie do strony internetowej <span id="a11y-url">'.site_url('').'</span>.</p>
   

    <p id="a11y-status">'.$status_text.'<br>Deklarację sporządzono dnia: <span id="a11y-data-sporzadzenie"> '.$status_data.'</span>.<br>
    Deklarację sporządzono na podstawie samooceny przeprowadzonej przez podmiot publiczny<br>
Na stronie internetowej można korzystać ze standardowych skrótów klawiaturowych.</p>
    
    
    
    <p id="a11y-kontakt">
    W przypadku problemów z dostępnością strony internetowej prosimy o kontakt. Osobą kontaktową jest <span id="a11y-osoba">'.$kontakt_nazwa.'</span>, 
    <span id="a11y-email">'.$kontakt_email.'</span>. 
    Kontaktować można się także dzwoniąc na numer telefonu <span id="a11y-telefon">'.$kontakt_telefon.'</span>. 
    Tą samą drogą można składać wnioski o udostępnienie informacji niedostępnej oraz składać żądania zapewnienia dostępności.
    </p>
    
    <p id="a11y-procedura"> Każdy ma prawo do wystąpienia z żądaniem zapewnienia dostępności cyfrowej strony internetowej, aplikacji mobilnej lub jakiegoś ich elementu. Można także zażądać udostępnienia informacji za pomocą alternatywnego sposobu dostępu, na przykład przez odczytanie niedostępnego cyfrowo dokumentu, opisanie zawartości filmu bez audiodeskrypcji itp. Żądanie powinno zawierać dane osoby zgłaszającej żądanie, wskazanie, o którą stronę internetową lub aplikację mobilną chodzi oraz sposób kontaktu. Jeżeli osoba żądająca zgłasza potrzebę otrzymania informacji za pomocą alternatywnego sposobu dostępu, powinna także określić dogodny dla niej sposób przedstawienia tej informacji. Podmiot publiczny powinien zrealizować żądanie niezwłocznie, nie później niż w ciągu 7 dni od dnia wystąpienia z żądaniem. Jeżeli dotrzymanie tego terminu nie jest możliwe, podmiot publiczny niezwłocznie informuje o tym wnoszącego żądanie, kiedy realizacja żądania będzie możliwa, przy czym termin ten nie może być dłuższy niż 2 miesiące od dnia wystąpienia z żądaniem. Jeżeli zapewnienie dostępności cyfrowej nie jest możliwe, podmiot publiczny może zaproponować alternatywny sposób dostępu do informacji. W przypadku, gdy podmiot publiczny odmówi realizacji żądania zapewnienia dostępności lub alternatywnego sposobu dostępu do informacji, wnoszący żądanie możne złożyć skargę w sprawie zapewniana dostępności cyfrowej strony internetowej, aplikacji mobilnej lub elementu strony internetowej, lub aplikacji mobilnej. Po wyczerpaniu wskazanej wyżej procedury można także złożyć wniosek do Rzecznika Praw Obywatelskich.</p>
  
  	'.$architektura.'
    
    
    
	
	
	<p>Data publikacji: <span id="a11y-data-publikacja">'.date ("Y-m-d", filemtime(__FILE__)).'</span>, data aktualizacji: <span id="a11y-data-aktualizacja">'.date ("Y-m-d").'</span></p>

            </div>
            
            
            
            
            
            '
        );

        return $deklaracja_pages;
    }

    /**
     * deklaracjas get posts result
     *
     * @param $posts
     *
     * @return array|null
     */
    public function deklaracja_pages( $posts ) {
        global $wp, $wp_query;
        $deklaracja_pages       = self::get_deklaracja_pages();
        $deklaracja_pages_slugs = array();
        foreach ( $deklaracja_pages as $slug => $fp ) {
            $deklaracja_pages_slugs[] = $slug;
        }
        if ( true === in_array( strtolower( $wp->request ), $deklaracja_pages_slugs )
             || ( true === isset( $wp->query_vars['page_id'] )
                  && true === in_array( strtolower( $wp->query_vars['page_id'] ), $deklaracja_pages_slugs )
            )
        ) {
            if ( true === in_array( strtolower( $wp->request ), $deklaracja_pages_slugs ) ) {
                $deklaracja_page = strtolower( $wp->request );
            } else {
                $deklaracja_page = strtolower( $wp->query_vars['page_id'] );
            }
            $posts                  = null;
            $posts[]                = self::create_deklaracja_page( $deklaracja_page, $deklaracja_pages[ $deklaracja_page ] );
            $wp_query->is_page      = true;
            $wp_query->is_singular  = true;
            $wp_query->is_home      = false;
            $wp_query->is_archive   = false;
            $wp_query->is_category  = false;
            $wp_query->is_deklaracja_page = true;
            $wp_query->deklaracja_page    = $wp->request;
            //Longer permalink structures may not match the deklaracja post slug and cause a 404 error so we catch the error here
            unset( $wp_query->query["error"] );
            $wp_query->query_vars["error"] = "";
            $wp_query->is_404              = false;
        }

        return $posts;
    }

    /**
     * Creates virtual deklaracja page
     *
     * @param $pagename 
     * @param $page
     *
     * @return stdClass
     */
    private static function create_deklaracja_page( $pagename, $page ) {
        $post                 = new stdClass;
        $post->post_author    = 1;
        $post->post_name      = $pagename;
        $post->guid           = get_bloginfo( 'wpurl' ) . '/' . $pagename;
        $post->post_title     = $page['title'];
        $post->post_content   = $page['content'];
		
        $post->ID             = - 1;
        $post->post_status    = 'static';
        $post->comment_status = 'closed';
        $post->ping_status    = 'closed';
        $post->comment_count  = 0;
        $post->post_date      = current_time( 'mysql' );
        $post->post_date_gmt  = current_time( 'mysql', 1 );

        return $post;
    }
}

if(get_option('deklaracjadostepnosci_on', '0')){
new deklaracjaPages();	
}



